/*
 * Project: Sudoku Explainer
 * Copyright (C) 2006-2007 Nicolas Juillerat
 * Copyright (C) 2013-2020 Keith Corlett
 * Available under the terms of the Lesser General Public License (LGPL)
 */
package diuf.sudoku;

import static diuf.sudoku.TestHelp.*;
import static org.junit.Assert.*;
import org.junit.Test;


/**
 * CmnBudsTest tests Grid.cmnBuds.
 *
 * @author Keith Corlett 2020-10-18
 */
public class CmnBudsTest {

// this is just a random puzzle
private static final String ALS_XZ_DOUBLE_LINKED
=".......3.6..5..18..83.1..2....9573...6.....92...........6...254.487...13..23....." + NL
+"24579,12579,14579,2468,24789,2489,45679,,5679,,279,479,,23479,2349,,,79,4579,,,46,,49,45679,,5679,1248,12,14,,,,,46,168,134578,,1457,148,348,1348,578,,,1345789,13579,14579,1248,2368,123468,578,47,1578,37,37,,18,89,189,,,,59,,,,26,256,69,,,159,159,,,46,456,6789,67,6789";
/*
.......3.6..5..18..83.1..2....9573...6.....92...........6...254.487...13..23.....
24579,12579,14579,2468,24789,2489,45679,,5679,,279,479,,23479,2349,,,79,4579,,,46,,49,45679,,5679,1248,12,14,,,,,46,168,134578,,1457,148,348,1348,578,,,1345789,13579,14579,1248,2368,123468,578,47,1578,37,37,,18,89,189,,,,59,,,,26,256,69,,,159,159,,,46,456,6789,67,6789
C:/Users/User/Documents/SodukuPuzzles/HoDoKu/ALS-XZ_DoubleLinked_001.txt
http://hodoku.sourceforge.net/en/tech_als.php
ALS_XZ	ALS-XZ: B4, C4, B2, C2, I2 on 24 and - (A4-1, A5-1, A6-1, B1-2, B6-1, C1-4, C5-14, C6-14, E2-79, F2-9, I4-1)
*/

@Test
public void test1() {
	grid = new Grid(ALS_XZ_DOUBLE_LINKED);
	final String testName = testName(this);
	// the cells to find the common buddies of
	Idx idx = Idx.parse("A1, B1, C1, B2, C2");
	Idx expResult = Idx.parse("A2, A3, B3, C3");
	Idx result = grid.cmnBuds(idx, new Idx());
	assertEquals(expResult, result);
}

@Test
public void test2() {
	grid = new Grid(ALS_XZ_DOUBLE_LINKED);
	final String testName = testName(this);
	// the cells to find the common buddies of
	Idx idx = Idx.parse("A4, B4, C4, H4");
	Idx expResult = Idx.parse("D4, E4, F4, G4, I4");
	Idx result = grid.cmnBuds(idx, new Idx()); // D1 E1 F1 G1 I1
	assertEquals(expResult, result);
}

}
