/*
 * Project: Sudoku Explainer
 * Copyright (C) 2006-2007 Nicolas Juillerat
 * Copyright (C) 2013-2020 Keith Corlett
 * Available under the terms of the Lesser General Public License (LGPL)
 */
package diuf.sudoku;

import diuf.sudoku.Grid.ARegion;
import diuf.sudoku.Grid.Cell;
import diuf.sudoku.io.IO;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.LinkedList;
import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;
import static diuf.sudoku.TestHelp.*;
import static diuf.sudoku.GridTestHelp.*;

/**
 * I thought I should do some automated testing. This is my first attempt.
 * I expect that I will resoundingly suck at it, and that consequently this
 * class will suck dogs, ummm things, so please do NOT use it as an example.
 * <p>
 * It's important that I test the basics like the constructors, equals, and
 * toString methods first, because my other tests are bunkum if they no work.
 * <p>
 * I figured out how to run my tests in order. Just use a ____ing batch file.
 * See {@code .\RunTest.bat}. I love it when these Caption Complexity muppets
 * build a multi-thousand dollar framework that's out-done by 50c solution
 * line a ____ing batch file. Real men use unix. Lol.
 * <p>
 * @author Keith Corlett 2018 Apr
 */
public final class GridTest {

private static final String EMPTY_GRID
="................................................................................." + NL
+"123456789,123456789,123456789,123456789,123456789,123456789,123456789,123456789,123456789,"
+"123456789,123456789,123456789,123456789,123456789,123456789,123456789,123456789,123456789,"
+"123456789,123456789,123456789,123456789,123456789,123456789,123456789,123456789,123456789,"
+"123456789,123456789,123456789,123456789,123456789,123456789,123456789,123456789,123456789,"
+"123456789,123456789,123456789,123456789,123456789,123456789,123456789,123456789,123456789,"
+"123456789,123456789,123456789,123456789,123456789,123456789,123456789,123456789,123456789,"
+"123456789,123456789,123456789,123456789,123456789,123456789,123456789,123456789,123456789,"
+"123456789,123456789,123456789,123456789,123456789,123456789,123456789,123456789,123456789,"
+"123456789,123456789,123456789,123456789,123456789,123456789,123456789,123456789,123456789";

////DO NOT DELETE THIS, IT CAN BE REUSED TO REGENERATE THE FILE CONTENT.
////to generate this file uncomment the saveInToStringFormatTo line
////in testRebuildEverything open it in the IDE and copy/paste it's contents
////into the below REBUILT constant.
//	public static final File REBUILT_FILE
//			= new File(TEST_DATA_DIR+"top1465.d3.1.REBUILT.txt");

public static final String REBUILT
="7.....4...2..7..83.53..8.79...5.63...6..2..9...1..7..6...3529...3..49.6..49..1.35" + NL
+",189,68,1269,1369,35,,125,12,1469,,46,1469,,45,156,,,146,,,1246,16,,126,,,2489,789,2478,,189,,,124,12478,3458,,4578,148,,34,1578,,1478,234589,89,,489,389,,258,245,,168,178,678,,,,,14,1478,1258,,2578,78,,,1278,,1278,268,,,678,68,,278,,";

private Grid grid;

@Before
public void setUp() {
	grid = new Grid();
}

/**
 * Test Grid() Constructor
 * and the toString() and equals(Object) methods.
 */
@Test
public void t000_testGridConstructor_1() {
	final String testName = testName(this);
	// setUp() grid = new Grid()
	Grid emptyGrid = new Grid();
	String result = emptyGrid.toString();
	assertEquals(EMPTY_GRID, result);
}

/**
 * Test Grid(String line) Constructor
 * and the toString() and equals(Object) methods.
 */
@Test
public void t001_testGridConstructor_2() {
	final String testName = testName(this);
	// setUp() grid = new Grid()
	Grid myGrid = new Grid(LONG_STRING_3);
	assertEquals(LONG_STRING, myGrid.toString());
}

//Grid(File) not used
///**
// * Test Grid(File file) Constructor
// * and the toString() and equals(Object) methods.
// */
//@Test
//public void t002_testGridConstructor_3() {
//	final String testName = testName(this);
//	// setUp() grid = new Grid()
//	final String exp
//="7.....4...2..7..83.53..8.79...5.63...6..2..9...1..7..6...3529...3..49.6..49..1.35" + NL
//+",189,68,269,1369,35,,25,12,19,,46,19,,45,56,,,146,,,24,16,,126,,,289,79,27,,189,,,14,48,35,,45,18,,34,178,,78,34,89,,489,39,,25,25,,168,178,678,,,,,14,478,158,,2578,78,,,178,,12,28,,,678,68,,278,,";
//	try {
//		Grid myGrid = new Grid(TEST_DATA_FILE);
//		//System.out.println(myGrid.toString());
//		//assertEquals(LONG_STRING, myGrid.toString());
//		assertEquals(exp, myGrid.toString());
//	} catch (IOException ex) {
//		System.err.println(ex.getClass().getSimpleName()+": "+ex.getMessage());
//		fail(testName+" error!");
//	}
//}

/**
 * Test Grid(Grid src) Copy-Constructor
 * and the Grid(String line) Constructor
 * and the toString() and equals(Object) methods.
 */
@Test
public void t003_testGridCopyConstructor() {
	final String testName = testName(this);
	// setUp() grid = new Grid()
	grid.load(LONG_STRING);
	Grid copy = new Grid(grid);
	assertEquals(LONG_STRING, copy.toString());
}

/**
 * Test Grids {@code public boolean load(List<String> lines)} method
 * and the toString() and equals(Object) methods.
 */
@Test
public void t004_testLoad() {
	final String testName = testName(this);
	// setUp() grid = new Grid()
	final String exp
="7.....4...2..7..83.53..8.79...5.63...6..2..9...1..7..6...3529...3..49.6..49..1.35" + NL
+",189,68,269,1369,35,,25,12,19,,46,19,,45,56,,,146,,,24,16,,126,,,289,79,27,,189,,,14,48,35,,45,18,,34,178,,78,34,89,,489,39,,25,25,,168,178,678,,,,,14,478,158,,2578,78,,,178,,12,28,,,678,68,,278,,";
	try {
		ArrayList<String> lines = IO.slurp(TEST_DATA_FILE);
		Grid myGrid = new Grid();
		if ( !myGrid.load(lines) )
			fail("load failed.");
		//System.out.println(myGrid.toString());
		//assertEquals(LONG_STRING, myGrid.toString());
		assertEquals(exp, myGrid.toString());
	} catch (IOException ex) {
		System.err.println(ex.getClass().getSimpleName()+": "+ex.getMessage());
		fail(testName+" error!");
	}
}

/**
 * Test Grids isFull method.
 */
@Test
public void t005_testIsFull() {
	final String testName = testName(this);
	// setUp() grid = new Grid()
	// this grid is not filled
	assertEquals(false, grid.isFull());
	// the solution grid is filled
	Grid filled = new Grid(SOLUTION);
	assertEquals(true, filled.isFull());
}

/**
 * Test Grids equals(Object) method
 * and testGridConstructor_2.
 */
@Test
public void test006_Equals() {
	final String testName = testName(this);
	// setUp() grid = new Grid()
	grid.load(LONG_STRING_3);
	Object myGrid = new Grid(LONG_STRING_3);
	assertEquals(grid, myGrid);
	// change one of the maybes on the grid
	grid.get("B1").canNotBe(1);
	assertNotEquals(grid, myGrid);
}

/**
 * Test Grids copyTo method
 * and testGridConstructor_2 and equals(Object) method.
 */
@Test
public void testCopyTo() {
	final String testName = testName(this);
	// setUp() grid = new Grid()
	grid.load(LONG_STRING_3);
	Grid copy = new Grid();
	grid.copyTo(copy);
	assertEquals(grid, copy);
}

/**
 * Test Grids copyToClipboard and pasteClipboardTo methods
 * and testGridConstructor_2 and equals(Object) method.
 * @throws java.io.IOException from the paste operation.
 */
@Test
public void testCopyToAndPasteFromClipboard() throws IOException {
	final String testName = testName(this);
	// setUp() grid = new Grid()
	grid.load(LONG_STRING_3);
	grid.copyToClipboard();
	Grid copy = new Grid();
	GridFactory.pasteClipboardTo(copy);
	if ( !copy.equals(grid) )
		fail("testCopyToAndPasteFromClipboard: copy != grid.\n"
				+"grid: "+grid+"\ncopy:"+copy);
}

/**
 * Test of rebuildEverything method, of class Grid.
 */
@Test
public void testRebuildEverything() {
	final String testName = testName(this);
	// setUp() grid = new Grid()
	int bits, v, i, cnt;
	boolean found;

	grid.load(LONG_STRING_3);
	grid.rebuildMaybesAndS__t();

	// check rebuildClearCellValuesFromSiblings
	// no sibling maybe any set cells value
	for ( Cell cell : grid.cells ) {
		if ( (bits=cell.maybes.bits) != 0 )
			for ( v=1; v<10; ++v) // 81*9 = 729
				if ( (bits & 1<<(v-1)) != 0 )
					for ( ARegion region : cell.regions ) // 729*3 = 2,187
						for ( Cell sib : region.cells ) // 2187*9 = 19,638
							if ( sib!=cell && cell.value==v )
								fail("testRebuildEverything: "
		+cell.id+"{"+cell.maybes+"} but sibling "+sib.id+"="+sib.value);
	}

	// check rebuildAllRegionsEmptyCellCounts
	for (ARegion region : grid.regions) {
		region.emptyCellCount(); // which sets r.emptyCellCount
		cnt = 0;
		for ( i=0; i<9; ++i )
			if ( region.cells[i].value == 0 )
				++cnt;
		if ( region.emptyCellCount != cnt )
			fail("testRebuildEverything: "+region.id+"emptyCellCount != "+cnt);
	}

	// rebuildAllRegionsContainsValues sets the region.containsValue arrays
	grid.rebuildAllRegionsContainsValues();
	
	for (ARegion region : grid.regions)
		for ( v=1; v<10; ++v ) {
			found = false;
			for ( i=0; i<9; ++i )
				if ( region.cells[i].value == v ) {
					found = true;
					break;
				}
			if ( region.containsValue[v] != found)
				fail("testRebuildEverything: "+region.id+".containsValue("+v+") != "+found);
		}

	// check rebuildAllRegionsIndexesOfAllValues // uses region.containsValue
	Indexes riv = new Indexes(); // regionsIndexesOfValue
	for (ARegion region : grid.regions) {
		final Cell[] rc = region.cells;
		for ( v=1; v<10; ++v ) { // 27*9 = 243
			riv.clear();
			for ( i=0; i<9; ++i ) // index: 243*9 = 2,187
				riv.set(i, (rc[i].maybes.bits & 1<<(v-1))!=0); // O(1)
			if ( riv.bits != region.indexesOf[v].bits )
				fail("testRebuildEverything: "+region.id+".riv["+v+"]={"
						+region.indexesOf[v].bits+"} != "+riv);
		}
	}

//	if ( !grid.saveInToStringFormatTo(REBUILT_FILE) )
//		fail("testRebuildEverything: failed to save "+REBUILT_FILE);

	Grid post = new Grid();
	post.load(REBUILT);
	if ( !post.equals(grid) )
		fail("testRebuildEverything: grid != post");
}

/**
 * Test of cancelMaybes method, of class Grid.
 */
@Test
public void testCancelMaybes() {
	final String testName = testName(this);
	// setUp() grid = new Grid()
	grid.load(LONG_STRING_3);
	// Set E4 = 8 (the correct value for this cell, from the solution)
	grid.get("E4").value = 8;
	grid.cancelMaybes();
	Grid post = new Grid();
	post.load(LONG_STRING_3);
	post.get("E4").set(8, 0, false, null);
	if ( !grid.equals(post) )
		fail("testCancelMaybes: grid != post");
}

/**
 * Test of isInvalidated method, of class Grid. NB: isInvalidated is just:
 * return hasMissingMaybes() || firstDoubledValue()!=0 || hasHomelessValues();
 */
@Test
public void testIsInvalidated() {
	final String testName = testName(this);

	grid.load(LONG_STRING_3);

	// valid grid
	assertEquals(false, grid.isInvalidated());

	// hasMissingMaybes()
	// clear E4s maybes
	grid.get("E4").maybes.clear();
	assertEquals(true, grid.hasMissingMaybes());

	// firstDoubledValue()!=0
	grid.load(LONG_STRING_3); // revert to valid grid
	// set C1=4
	grid.get("C1").value = 4;
	assertEquals(4, grid.firstDoubledValue());

	// hasHomelessValues(): We'll make 1 homeless on row 4
	grid.load(LONG_STRING_3); // revert to valid grid
	// first we assure that 1 is not set on "row 4"
	for ( Cell c : grid.rows[3].cells )
		assert c.value != 1;
	// clear "row 4"s indexes of 1
	// NB: Don't change the actual maybes, just the index.
	grid.rows[3].indexesOf[1].clear();
	assertEquals(true, grid.hasHomelessValues());
}

/**
 * Test of countFilledCells method, of class Grid.
 */
@Test
public void testCountFilledCells() {
	final String testName = testName(this);
	grid.load(LONG_STRING_3);
	assertEquals(33, grid.countFilledCells());
}

/**
 * Test of countMaybes method, of class Grid.
 */
@Test
public void testCountMaybes() {
	final String testName = testName(this);
	grid.load(LONG_STRING_3);
	assertEquals(154, grid.countMaybes());
}

/**
 * Test of countOccurances method, of class Grid.
 */
@Test
public void testCountOccurances() {
	final String testName = testName(this);
	grid.load(LONG_STRING_3);
	int[] expected = new int[] {48,2,3,6,3,4,4,4,2,5};
	int[] actual = grid.countOccurances();
	assertArrayEquals(expected, actual);
}

/**
 * Test of restore method, of class Grid.
 */
@Test
public void testRestore() {
	final String testName = testName(this);
	grid.load(LONG_STRING_3);
	for ( int x=0; x<9; ++x)
		grid.cells[36+x].value = 1; // 4*9=36
	grid.restore(LONG_STRING);
	if ( !LONG_STRING.equals(grid.toString()) )
		fail("testRestore: strings differ");
}

/**
 * Test of toShortString method, of class Grid.
 */
@Test
public void testToShortString() {
	final String testName = testName(this);
	grid.load(LONG_STRING_3);
	assertEquals(SHORT_STRING, grid.toShortString());
}

/**
 * Test of hashCode method, of class Grid.
 */
@Test
public void testHashCode() {
	final String testName = testName(this);
	// I don't think it matters what the hashCode is, so long as it's not 0.
	grid.load(LONG_STRING_3);
	assertNotEquals(0, grid.hashCode()); // actually it's 4143
}

/**
 * Test of commonRegion method, of class Grid.
 */
@Test
public void testCommonRegion() {
	final String testName = testName(this);
	grid.load(LONG_STRING_3);
	Collection<Cell> cells = new LinkedList<>();
	cells.add(grid.get("H4"));
	cells.add(grid.get("I5"));
	cells.add(grid.get("H6"));
	assertEquals("box 6", grid.commonRegion(cells, Grid.BOX).id);
}

}