/*
 * Project: Sudoku Explainer
 * Copyright (C) 2006-2007 Nicolas Juillerat
 * Copyright (C) 2013-2020 Keith Corlett
 * Available under the terms of the Lesser General Public License (LGPL)
 */
package diuf.sudoku;

import static diuf.sudoku.TestHelp.*;
import java.io.File;

/**
 * static import Constants that are common to GridTest and GridCellTest, but 
 * not to all the other tests which use the helper methods.
 * @author Keith Corlett
 */
public final class GridTestHelp {

// C:\\Users\\User\\Documents\\NetBeansProjects\\DiufSudoku\\test\\data\\top1465.d3.1.txt
public static final File TEST_DATA_FILE = new File(TEST_DATA_DIR+"top1465.d3.1.txt");

// this string contains the contents of TEST_DATA_FILE: top1465.d3.1.txt
public static final String SHORT_STRING
="7.....4...2..7..83.53..8.79...5.63...6..2..9...1..7..6...3529...3..49.6..49..1.35";

// this string contains the contents of TEST_DATA_FILE: top1465.d3.1.txt
public static final String LONG_STRING = SHORT_STRING + NL
+",189,68,1269,1369,35,,125,12,1469,,46,1469,,45,156,,,146,,,1246,16,,126,,,2489,789,2478,,189,,,124,12478,3458,,4578,148,,34,1578,,1478,234589,89,,489,389,,258,245,,168,178,678,,,,,14,1478,1258,,2578,78,,,1278,,1278,268,,,678,68,,278,,";

// this string contains the contents of TEST_DATA_FILE: top1465.d3.1.txt
public static final String LONG_STRING_3 = LONG_STRING + NL
+TEST_DATA_FILE.getAbsolutePath();

/*
LONG_STRING_3:
7.....4...2..7..83.53..8.79...5.63...6..2..9...1..7..6...3529...3..49.6..49..1.35
,189,68,1269,1369,35,,125,12,1469,,46,1469,,45,156,,,146,,,1246,16,,126,,,2489,789,2478,,189,,,124,12478,3458,,4578,148,,34,1578,,1478,234589,89,,489,389,,258,245,,168,178,678,,,,,14,1478,1258,,2578,78,,,1278,,1278,268,,,678,68,,278,,
C:\Users\User\Documents\NetBeansProjects\DiufSudoku\test\data\top1465.d3.1.txt
*/

// to generate this String open TEST_DATA_FILE in the GUI, F8,F4 to "Solve", 
// Ctrl-C to copy the solution to the clipboard, and then paste it in here.
public static final String SOLUTION
="798635421126974583453218679972586314564123897381497256617352948835749162249861735";

}
