/*
 * Project: Sudoku Explainer
 * Copyright (C) 2006-2007 Nicolas Juillerat
 * Copyright (C) 2013-2020 Keith Corlett
 * Available under the terms of the Lesser General Public License (LGPL)
 */
package diuf.sudoku.solver.checks;

import org.junit.Test;
import static org.junit.Assert.*;
import static diuf.sudoku.TestHelp.*;
import diuf.sudoku.solver.AHint;
import diuf.sudoku.solver.AWarningHint;
import diuf.sudoku.solver.hinters.AHinter;


/**
 * Tests the NoDoubleValues, an AWarningHinter.
 * @author Keith Corlett 2018 Mar
 */
public final class NoDoubleValuesTest {
	
private static final String PUZZLE
="7....74...2..7..8...3..8..9...5..3...6..2..9...1..7..6...3..9...3..4..6...9..1..5" + NL
+",1589,568,1269,13569,,,1235,123,14569,,456,1469,,34569,156,,13,1456,145,,1246,156,,12567,1257,,2489,4789,2478,,1689,469,,1247,12478,3458,,4578,148,,34,1578,,1478,234589,4589,,489,389,,258,245,,124568,14578,245678,,568,256,,1247,12478,1258,,2578,2789,,259,1278,,1278,2468,478,,2678,68,,278,2347,";
//1#C:\\Users\\User\\Documents\\SodukuPuzzles\\MagicTour\\top1465.d3.mt

/** Test NoDoubleValues.getHints. */
@Test
public void test()  {
	final String testName = testName(this);
	AHinter hinter = new NoDoubleValues();
	getHints(PUZZLE, hinter);
	AHint hint = accu.getHint();
	String html = hint.toHtml();
	if ( !(hint instanceof AWarningHint) ) {
		System.out.println("actual: "+hint.getClass().getName());
		fail("expected: AWarningHint");
	}
	if ( !html.contains("Multiple 7's in box 2") ) {
		System.out.println("actual: "+html);
		fail("expected: Multiple 7's in box 2");
	}
}
	
}
